// Virtual Modeller V0.5GL  for MS Visual C++ V4.2   12.12.1997  Michael Granz
//
// MainFrm.cpp : implementation of the CMainFrame class

#include "stdafx.h"
#include "general.h"
#include "VModel.h"
#include "TextWin.h"

#include "MainFrm.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
  static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =           // status line indicator
{
  ID_SEPARATOR,
  ID_INDICATOR_CAPS,
  ID_INDICATOR_NUM,
  ID_INDICATOR_SCRL,
};

CMainFrame::CMainFrame()
{
  // TODO: add member initialization code here
}

CMainFrame::~CMainFrame() {}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  if (CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;
	
  if (!m_wndToolBar.Create(this) || !m_wndToolBar.LoadToolBar(IDR_MAINFRAME)) {
    TRACE0("Failed to create toolbar\n");
    return -1;
  }

  if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))) {
    TRACE0("Failed to create status bar\n");
    return -1;
  }

  m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
  m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
  EnableDocking(CBRS_ALIGN_ANY);
  DockControlBar(&m_wndToolBar);
  return 0;
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
  // remove this flag to remove " - Untitled" from the frame's caption
  cs.style &= ~ FWS_ADDTOTITLE;
  return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG

  void CMainFrame::AssertValid() const
  {
    CFrameWnd::AssertValid();
  }

  void CMainFrame::Dump(CDumpContext& dc) const
  {
    CFrameWnd::Dump(dc);
  }

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
  CFrameWnd::OnPaletteChanged(pFocusWnd);
  if(pFocusWnd != this) OnQueryNewPalette();
}


BOOL CMainFrame::OnQueryNewPalette() 
{
  /*WORD           i;
  CPalette      *pOldPal;
  CVModelView   *pView = (CVModelView *)GetActiveView();
  CClientDC      dc(pView);

  pOldPal = dc.SelectPalette(&pView->m_cPalette, FALSE);
  i = dc.RealizePalette();
  dc.SelectPalette(pOldPal, FALSE);

  if(i>0) InvalidateRect(NULL);*/
        
  return CFrameWnd::OnQueryNewPalette();
}

void CMainFrame::OnClose() 
{
  TextWin.KeyIn("Quit\n");
}
