// VModelView.h : interface of the CVModelView class
//
/////////////////////////////////////////////////////////////////////////////

class CVModelView : public CView
{
  protected: // create from serialization only
    CVModelView();
    DECLARE_DYNCREATE(CVModelView)

  // Attributes
  public:
    CVModelDoc*  GetDocument();

  // Operations
    public:

  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVModelView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

  // Implementation
  public:
    virtual ~CVModelView();
    #ifdef _DEBUG
      virtual void AssertValid() const;
      virtual void Dump(CDumpContext& dc) const;
    #endif

  protected:

  // Generated message map functions
  protected:
	//{{AFX_MSG(CVModelView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VModelView.cpp
  inline CVModelDoc* CVModelView::GetDocument() { return (CVModelDoc*)m_pDocument; }
#endif

extern CVModelView *VMView;